//----------------------------------------------------------------------//
//je[u															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include "holiday.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
const _TCHAR WeekStrJ[7][4]
	 = {_T(""), _T(""), _T(""), _T(""), _T(""), _T(""), _T("y")};
const _TCHAR WeekStrE[7][10]
	 = {_T("Sunday"), _T("Monday"), _T("Tuesday"), _T("Wednesday"),
	    _T("Thursday"), _T("Friday"), _T("Saturday")};

const _TCHAR MonthStrE[12][10]
	 = {_T("January"), _T("February"), _T("March"), _T("April"), _T("May"), _T("June"),
	    _T("July"), _T("August"), _T("September"), _T("October"), _T("November"), _T("December")};

//--------------------------------------
//wN̓擾
//--------------------------------------
int get_dayn(int y, int m)
{
	int d;
	switch (m) {
	case 2:
    	if (y%4==0 && y%100!=0 || y%400==0) d = 29; else d = 28;
		break;
	case 4: case 6: case 9: case 11:
		d = 30;
		break;
	default:
		d = 31;
	}
	return d;
}

//--------------------------------------
//wN̗j擾
// 1:,2: ` 7:y
//--------------------------------------
int get_wek(int y, int m, int d)
{
	if (m<3) {
		y--; m += 12;
	}
	return ((y + y/4 - y/100 + y/400 + (26*m+16)/10 + d) % 7) +1;
}

//--------------------------------------
//wN̑n wj(1`7)̓擾
//--------------------------------------
int get_wday(int y, int m, int w, int n)
{
	int d = 1;
	while (get_wek(y,m,d)!=w) d++;	//1 wj߂

	int i = 1;
	while (i<n) {
		d += 7; i++;
	}
	return d;
}


//---------------------------------------------------------------------------
// je[u NX
//---------------------------------------------------------------------------
HolidayTable::HolidayTable()
{
	Year  = 0;
	Count = 0;
}

//--------------------------------------
//wN̏je[u쐬
//--------------------------------------
void HolidayTable::InitTable(int y)
{
	Year  = y;
	Count = 0;

	int m,d;

	Add( 1, 1, _T(""));
	if (y<2000) d = 15; else d = get_wday(y, 1,wixMON, 2);	//1 2j
	Add( 1, d, _T("l̓"));
	Add( 2,11, _T("LO̓"));
	d = (20843100+(y-1980)*242194)/1000000-(y-1980)/4;
	Add( 3, d, _T("t̓"));
	if (y<2007)  Add( 4,29, _T("݂ǂ̓")); else Add( 4,29, _T("a̓"));
	Add( 5, 3, _T("@LO"));
	if (y>=2007) Add( 5, 4, _T("݂ǂ̓"));
	Add( 5, 5, _T("ǂ̓"));
	if (y<2003) d = 20; else d = get_wday(y, 7,wixMON, 3);	//7 3j
	Add( 7, d, _T("C̓"));
	if (y>=2016) Add( 8,11, _T("R̓"));
	if (y<2003) d = 15; else d = get_wday(y, 9,wixMON, 3);	//9 3j
	Add( 9, d, _T("hV̓"));
	d = (23248800+(y-1980)*242194)/1000000-(y-1980)/4;
	Add( 9, d, _T("H̓"));
	if (y<2000) d = 10; else d = get_wday(y,10,wixMON, 2);	//10 2j
	Add(10, d, _T("̈̓"));
	Add(11, 3, _T("̓"));
	Add(11,23, _T("ΘJӂ̓"));
	Add(12,23, _T("Vca"));

	//jj̏ꍇ
	for (int i=0; i<Count; i++) {
		m = Table[i].m;
		d = Table[i].d;
		if (get_wek(y, m, d)==wixSUN) {
			for (;;) {
				d++;
				if (d>get_dayn(y, m)) {
					d = 1; m++;
				}
				if (y<2007) break;
					//(<2007 ̓j̏ꍇ͐Uւx
				if (!IsHoliday(y, m, d, NULL)) break;
					//(>=2007 ł߂ȕjvłȂ
			}
			Add(m, d, _T("Uւx"));
		}
	}

	//jɋ܂ꂽ͍̋x
	for (int i=0; i<Count; i++) {
		m = Table[i].m;
		d = Table[i].d;
		do {
			d--;	if (d==0) break;
			if (IsHoliday(y, m, d, NULL)) break;
			if (get_wek(Year, m, d)==wixSUN) break;
			d--;	if (d==0) break;
			if (!IsHoliday(y, m, d, NULL)) break;
			d++;
			Add(m, d, _T("̋x"));
		} while(0);
	}
}

//--------------------------------------
//e[uɏjǉ
//--------------------------------------
void HolidayTable::Add(int m, int d, _TCHAR *name)
{
	Table[Count].m = m;
	Table[Count].d = d;
	_tcscpy(Table[Count].name, name);
	Count++;
}

//--------------------------------------
//Nɂw茎̏j
// ߂l
//  true:j/ false:jł͂Ȃ
//  name: NULL łȂΏjԂ
//--------------------------------------
bool HolidayTable::IsHoliday(int y, int m, int d, _TCHAR *name)
{
	if (y!=Year) InitTable(y);
	int n = -1;
	for (int i=0; i<Count; i++) {
		if (Table[i].m==m && Table[i].d==d) {
			n = i; break;
		}
	}
	if (name!=NULL) {
		if (n==-1)
			name[0]= '\0';
		else
			_tcscpy(name, Table[n].name);
	}
	return (n!=-1);
}
//---------------------------------------------------------------------------
